<?php

namespace Supportingcast\Shortcodes;

abstract class Template
{
	protected $params;
	protected $wrap = true;

	public function __construct(?array $params = null)
	{
		$this->params = $params;
	}

	public function handle()
	{
		ob_start();

		$this->render();

		$content = ob_get_clean();

		if ($this->wrap) {
			return $this->wrap($content);
		}

		return $content;
	}

	protected function wrap($content)
	{
		return "<div class=\"supportingcast\">{$content}</div>";
	}

	protected function render()
	{
		//no-op: fill in on child classes
	}
}