<?php
namespace Supportingcast\Woocommere;

use Supportingcast\ScProducts;

AdminSettings::boot();

class AdminSettings
{
	const META_PRODUCT_ID = 'supportingcast_product_id';


    public static function boot()
    {
        $adminSettings = new AdminSettings();

	    add_action('admin_init', [$adminSettings, 'settings_init'], 11);

    }

    public function settings_init() {
	    add_settings_section(
		    'supporting-cast-woocommerce', // id of the section
		    'WooCommerce', // title to be displayed
		    [$this, 'woocommerce_render'], // callback function
		    'supporting-cast' // page on which to display the section
	    );

	    register_setting(
		    'supporting-cast',
		    'sc-woocommerce-order-status-access'
	    );


	    add_settings_field(
		    'sc-woocommerce-order-status-map', // id of the settings field
		    'Order statuses that grant access', // title
		    [$this, 'order_status_map'], // callback function
		    'supporting-cast', // page on which settings display
		    'supporting-cast-woocommerce' // section on which to show settings
	    );
    }

	function woocommerce_render() {
		?>
		<div class="sc-admin-woocommerce">
			<?php
			if (get_option('woocommerce_enable_guest_checkout') == 'yes'):
				?>
				<div class="sc-notice sc-notice-error">
					Guest Checkout is current enabled in WooCommerce. If a user does not create an account they will not be able to login and access linked content!<br>
					<a href="/wp-admin/admin.php?page=wc-settings&tab=account">Click here and disable "Allow customers to place orders without an account" to fix it</a>
				</div>
			<?php
			endif;
            ?>
        </div>
        <?php
    }

    function order_status_map() {
	    ?>
        <div class="sc-admin-woocommerce">
			<?php
			$values = get_option('sc-woocommerce-order-status-access', \Supportingcast\Woocommere\ProcessOrder::DEFAULT_STATUS_ACCESS);

            $options = wc_get_order_statuses();

			foreach($options as $key => $text) {
				$checked = (ProcessOrder::getAccessForStatus($key) == 1? 'checked ' : '');
				echo "<input type='hidden' name='sc-woocommerce-order-status-access[{$key}]' {$checked} value='0'>";
				echo "<input type='checkbox' name='sc-woocommerce-order-status-access[{$key}]' {$checked} value='1'>{$text} <br>";
			}
            ?>
        </div>
		<?php
	}

}