<?php

global $post;

use Supportingcast\ScFeeds;
use Supportingcast\ScProducts;

$scFeeds = new ScFeeds();
$scFeeds->getAll();

$scProductId = get_post_meta($post->ID, \Supportingcast\Woocommere\AdminProductData::META_PRODUCT_ID, true);

$feedIds = [];
$scStatus = "Product is not linked to Supporting Cast. Configure it below and hit save.";

if ($scProductId) {
    $scProduct = new ScProducts();
    try {
        $scProduct->getId($scProductId);
        $feedIds = $scProduct->feed_ids;
	    $scStatus = "Product has been created on Supporting Cast (#{$scProductId})";
    } catch (Exception $exception) {
        $scStatus = "Error: " . $exception->getMessage();
    }
}

?>
<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet" />
<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>

<div id="supportingcast_product_data" class="panel woocommerce_options_panel hidden">
    <p class="form-field">
        <label for="feed_ids"><?= __('Status', 'supportingcast') ?></label>
        <?= $scStatus ?>
    </p>
    <p class="form-field">
        <label for="feed_ids"><?= __('Feeds', 'supportingcast') ?></label>
        <select
            class="select2-feeds"
            name="supportingcast_feed_ids[]"
            id="supportingcast_feed_ids"
        ></select>
        <?= wc_help_tip( "Which feeds will this product give users access to.<BR> Changes will take affect immediately, even if you save this as a draft" ); ?>
    </p>
</div>

<script type="application/javascript">
    function scSelect2FormatFeedSelection (feed) {

        var baseUrl = "/user/pages/images/flags";
        var template = jQuery(
            '<span class="sc-select2-option" ><img /> <span></span></span>'
        );

        // Use .text() instead of HTML string concatenation to avoid script injection issues
        template.find("span").text(feed.name);
        template.find("img").attr("src", feed.image_url);

        return template;
    }

    jQuery(function() {
        jQuery(".select2-feeds").select2({
            data: <?= json_encode($scFeeds->data) ?>,
            multiple: true,
            templateSelection: scSelect2FormatFeedSelection,
            templateResult: scSelect2FormatFeedSelection,
            width: '90%',
        });

        jQuery(".select2-feeds").val(<?= json_encode($feedIds)?>);
        jQuery(".select2-feeds").change(); // trigger select2 update

    });

</script>

